SystemOrganization addCategory: #'Heracles-Live'!
SystemOrganization addCategory: #'Heracles-Styles'!
SystemOrganization addCategory: #'Heracles-Widgets'!
SystemOrganization addCategory: #'Heracles-Examples'!

!WAPresenter methodsFor: '*heracles' stamp: ''!
eval: aBlock printingResultsOn: html 
	| result |
	result := aBlock value.
	self renderResult: result on: html.
	html renderUpdates! !

!WAPresenter methodsFor: '*heracles' stamp: ''!
generateCallbackOn: html do: aBlock 
	^html idForLiveCallback: 
			[:parameters :h | 
			self eval: [aBlock value: parameters] printingResultsOn: h]! !

!WAPresenter methodsFor: '*heracles' stamp: ''!
installCallbacks: aSymbolOrCollection for: componentId on: html 
	| methodsToInstall installationCode |
	methodsToInstall := (aSymbolOrCollection isCollection 
				and: [aSymbolOrCollection isString]) 
					ifTrue: [Array with: aSymbolOrCollection]
					ifFalse: [aSymbolOrCollection].
	installationCode := String streamContents: 
					[:stream | 
					methodsToInstall do: 
							[:each | 
							| callbackId |
							callbackId := self generateCallbackOn: html
										do: [:args | self runMethodStartingWith: each withArguments: args] fixTemps.
							stream
								nextPutAll: 'xmlInstallCallback(';
								nextPutAll: componentId printString;
								nextPut: $,;
								nextPutAll: each asString printString;
								nextPut: $,;
								nextPutAll: html context actionUrl asString printString;
								nextPut: $,;
								nextPutAll: callbackId asString printString;
								nextPutAll: ');']].
	html script: installationCode! !

!WAPresenter methodsFor: '*heracles' stamp: ''!
renderError: error on: html 
	html attributes type: 'exception'.
	html response: [html text: error description encodeForHTTP]! !

!WAPresenter methodsFor: '*heracles' stamp: ''!
renderLiveUpdateOn: aRenderer 
	self nextPresentersDo: [:each | each renderLiveUpdateOn: aRenderer]! !

!WAPresenter methodsFor: '*heracles' stamp: ''!
renderResult: result on: html

	html attributes type: 'ok'.
	html response: [html text: result asString encodeForHTTP]! !

!WAPresenter methodsFor: '*heracles' stamp: ''!
runMethodStartingWith: aSymbol withArguments: args 
	| selectors selector |
	selectors := self class allSelectors 
				select: [:each | (each beginsWith: aSymbol) and: [each numArgs = args size]].
	selectors size = 1 
		ifTrue: [selector := selectors anyOne]
		ifFalse: [selector := aSymbol].
	^self perform: selector withArguments: args! !

!WAStandardScripts methodsFor: '*heracles' stamp: ''!
xmlLiveCallback
	^ '

function createDataPacket(parameters) {
	var dataPacket = "";
	for(var i=0; i<parameters.length; i++) {
		var param = parameters[i] + ""; // ensure parameter is a string
		dataPacket += param.length + "\r" + param + "\r";
	}

	return dataPacket;
}

function makeXmlCallback(uri, callbackId) {
	return callback;

	function callback() {
		// Copy arguments to the function into a temp array
		var argsCalledWith = new Array(arguments.length);
		for(var i=0; i<arguments.length; i++)
			argsCalledWith[i] = arguments[i];

		var customHandler = null;
		// If last arg passed in is a function then it is the results handler function
		if (argsCalledWith.length > 0) {
			if (typeof argsCalledWith[argsCalledWith.length-1] == "function")
				customHandler = argsCalledWith.pop();
		}

		// create a closure to send to liveUpdater to use
		function helper() {
			return addParameter(uri, callbackId, createDataPacket(argsCalledWith));
		};

		function xmlProcessCallbackResults(response) {
			var serverResult = new Object();
			for(i=0; i < response.documentElement.childNodes.length; i++) {
				var child = response.documentElement.childNodes[i];
				if (child.tagName == "response")
					serverResult.text = child.firstChild.data;
				else
					xmlLiveProcessOne(child);
			}
			if (customHandler) customHandler(serverResult);
		}

		xmlLiveUpdater(helper, xmlProcessCallbackResults)();
	};
}

function xmlInstallCallback(id, callbackName, uri, callbackId) {
	var element = document.getElementById(id);
	if (element == null) {
		window.setTimeout("xmlInstallCallback(''" + id + "'', ''" + callbackName + "'', ''" + uri + "','" + callbackId + "'')", 250);
		return;
	}
	element[callbackName] = makeXmlCallback(uri, callbackId);
}
'! !

!WAStandardScripts methodsFor: '*heracles' stamp: ''!
xmlLiveUpdate
	^'

function liveUpdateDOM(target, template) {
	var childrenFound = false;
	for(var child = template.firstChild; child; child = child.nextSibling) {
		if (child.nodeType == 1) {
			childrenFound = true;
			if (!!liveUpdateDOM(target[child.tagName], child))
				target[child.tagName] = child.firstChild.data;
		}
	}

	return childrenFound;
}

function xmlLiveProcessOne(child) {
	if (child.tagName == "innerHtml") {
		var elementId = child.getAttribute("id");
		var element = document.getElementById(elementId);
		element.innerHTML = child.firstChild.data;
	}

	if (child.tagName == "dom") {
		var elementId = child.getAttribute("id");
		var element = document.getElementById(elementId);
		liveUpdateDOM(element, child);
	}
	if (child.tagName == "script") {
		eval(child.firstChild.data);
	}
}

function xmlProcessResults(response) {
	for(i=0; i < response.documentElement.childNodes.length; i++) {
		var child = response.documentElement.childNodes[i];
		xmlLiveProcessOne(child);
	}
}

function xmlLiveUpdaterUri(uri) {
    return xmlLiveUpdater(function() { return uri; }, xmlProcessResults);
}

function xmlLiveUpdater(uriFunc, processResultsFunc)
{
    var request = false;

    if (window.XMLHttpRequest) {
       	request = new XMLHttpRequest();
    }
    
    function update()
    {
       if(request && request.readyState < 4)
            request.abort();
            
        if(!!window.XMLHttpRequest)
            request = new ActiveXObject("Microsoft.XMLHTTP");
        
        request.onreadystatechange = processRequestChange;
	   var uri = addParameter(uriFunc(), "timestamp", (new Date()).getTime().toString());

        request.open("POST", uri.split("?")[0]);
	   request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	   window.status = "Sending commands...";
        request.send(uri.split("?")[1]);
        return false;
    }
    
    function processRequestChange() {
		if(request.readyState == 4) {
		     window.status = "Getting new instructions...";
			if(request && request.responseXML && request.responseXML.documentElement) {
				processResultsFunc(request.responseXML);
				window.status = "Done";
			} else {
				document.location.reload();
			}

		}
    }

    return update;
}

'! !

Object subclass: #WACssStyle
	instanceVariableNames: 'string'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heracles-Styles'!

!WACssStyle class methodsFor: 'instance creation' stamp: ''!
new
	"Answer a newly created and initialized instance."

	^super new initialize! !

!WACssStyle methodsFor: 'converting' stamp: ''!
asString
	^string! !

!WACssStyle methodsFor: 'accessing' stamp: ''!
at: propertyName put: value
	| propertyValue property |
	propertyValue := value isString
		ifTrue: [value]
		ifFalse:
			[(#('left' 'right' 'width' 'top' 'bottom' 'height')
				includes: (propertyName tokensBasedOn: $-) last)
				ifTrue: [value printString , 'px']
				ifFalse: [value printString]].
	property := propertyName , ': ' , propertyValue , ';'.
	string isEmpty
		ifTrue: [string := property]
		ifFalse: [string := string , ' ' , property]! !

!WACssStyle methodsFor: 'converting' stamp: ''!
doesNotUnderstand: aMessage 
	aMessage arguments size = 1 
		ifTrue: 
			[| propertyName |
			propertyName := self propertyNameForSelector: aMessage selector.
			^self at: propertyName put: aMessage argument].
	^super doesNotUnderstand: aMessage! !

!WACssStyle methodsFor: 'accessing' stamp: ''!
extent: aPoint 
	self at: 'width' put: aPoint x.
	self at: 'height' put: aPoint y! !

!WACssStyle methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver."

	string := ''.
	^self! !

!WACssStyle methodsFor: 'accessing' stamp: ''!
origin: aPoint 
	self at: 'position' put: 'absolute'.
	self at: 'left' put: aPoint x.
	self at: 'top' put: aPoint y! !

!WACssStyle methodsFor: 'converting' stamp: ''!
propertyNameForSelector: aSelector 
	| resultStream |
	resultStream := (String new: aSelector size + 4) writeStream.
	aSelector do: 
			[:each | 
			each = $: 
				ifFalse: 
					[each isUppercase 
						ifFalse: [resultStream nextPut: each]
						ifTrue: 
							[resultStream
								nextPut: $-;
								nextPut: each asLowercase]]].
	^resultStream contents! !

Object subclass: #WAXmlFragmentRoot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heracles-Live'!

!WAXmlFragmentRoot methodsFor: 'As yet unclassified' stamp: ''!
writeOn: aStream! !

Object subclass: #WAXmlRoot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heracles-Live'!

!WAXmlRoot methodsFor: 'as yet unclassified' stamp: ''!
writeOn: aStream 
	aStream
		nextPutAll: '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>';
		cr! !

!WAHtmlRenderer methodsFor: '*heracles' stamp: ''!
anchorWithAction: actionBlock xmlLiveAction: liveBlock text: aString
	| uri id |
	id := self ensureId.
	self anchorWithAction: actionBlock text: aString.
	uri := self urlForLiveAction: [:t :h | liveBlock value: h].
	self script: 'document.getElementById(',id printString,').onclick = xmlLiveUpdaterUri(',uri asString printString, ')'! !

!WAHtmlRenderer methodsFor: '*heracles' stamp: ''!
attributeAt: name putCallback: aBlock scriptArguments: aString 
	| callbackId uri |
	callbackId := self idForLiveCallback: 
					[:p :h | 
					aBlock valueWithArguments: p.
					h renderUpdates].
	uri := context actionUrl asString.
	self attributeAt: name
		put: 'makeXmlCallback(' , uri printString , ',' , callbackId printString 
				, ')(' , aString 
				, ')'! !

!WAHtmlRenderer methodsFor: '*heracles' stamp: ''!
idForLiveCallback: aBlock 
	^self callbacks registerLiveActionCallback: 
			[:t :h | 
			| stream parameters len param |
			parameters := OrderedCollection new.
			stream := t readStream.
			[stream atEnd] whileFalse: 
					[len := stream nextLine asInteger.
					param := stream next: len.
					stream next.
					parameters add: param].
			aBlock value: parameters asArray value: h]! !

!WAHtmlRenderer methodsFor: '*heracles' stamp: ''!
onChangeDo: aBlock 
	self onChangeDo: aBlock scriptArguments: 'this.value'! !

!WAHtmlRenderer methodsFor: '*heracles' stamp: ''!
onChangeDo: aBlock scriptArguments: aString 
	self 
		attributeAt: 'onchange'
		putCallback: aBlock
		scriptArguments: aString! !

!WAHtmlRenderer methodsFor: '*heracles' stamp: ''!
selectFromList: aCollection selected: anObject callback: callbackBlock labels: formatBlock xmlLiveCallback: liveCallbackBlock 
	self 
		onChangeDo: [:index | liveCallbackBlock value: (aCollection at: index asInteger + 1)]
		scriptArguments: 'this.selectedIndex'.
	self 
		selectFromList: aCollection
		selected: anObject
		callback: callbackBlock
		labels: formatBlock! !

!WAHtmlRenderer methodsFor: '*heracles' stamp: ''!
urlForLiveAction: actionBlock 
	| url |
	url := context actionUrl 
				withParameter: (self callbacks registerLiveActionCallback: actionBlock).
	^url asString! !

WAHtmlRenderer subclass: #WAHtmlUpdateRenderer
	instanceVariableNames: 'processingInnerHtml pendingScripts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heracles-Live'!

!WAHtmlUpdateRenderer methodsFor: 'css' stamp: ''!
divNamed: anId with: aBlock 
	processingInnerHtml ifTrue: [^super divNamed: anId with: aBlock].
	self elementId: anId innerHtml: aBlock! !

!WAHtmlUpdateRenderer methodsFor: 'rebuilding' stamp: ''!
elementId: anId dom: aBlock 
	self
		attributeAt: 'id' put: anId;
		tag: 'dom' do: aBlock! !

!WAHtmlUpdateRenderer methodsFor: 'rebuilding' stamp: ''!
elementId: anId innerHtml: aBlock 
	| innerDocument outerDocument pcData |
	outerDocument := self context document.
	pcData := String new writeStream.
	innerDocument := WAXmlStreamDocument newFragment stream: pcData.
	processingInnerHtml := true.
	pendingScripts := OrderedCollection new.
	self context document: innerDocument.
	[self render: aBlock] ensure: 
			[self context document: outerDocument.
			processingInnerHtml := false].
	self
		attributeAt: 'id' put: anId;
		tag: 'innerHtml' cData: pcData contents.
	pendingScripts do: [:each | self script: each]! !

!WAHtmlUpdateRenderer methodsFor: 'accessing' stamp: ''!
initializeWithContext: aRenderingContext callbacks: aCallbackStore
	super initializeWithContext: aRenderingContext callbacks: aCallbackStore.
	processingInnerHtml := false! !

!WAHtmlUpdateRenderer methodsFor: 'rebuilding' stamp: ''!
renderUpdates
	(WARenderLiveNotification new renderer: self) raiseSignal! !

!WAHtmlUpdateRenderer methodsFor: 'html' stamp: ''!
script: aString 
	processingInnerHtml 
		ifTrue: [pendingScripts add: aString]
		ifFalse: [self tag: 'script' cData: aString]! !

!WAHtmlUpdateRenderer methodsFor: 'css' stamp: ''!
spanNamed: anId with: aBlock 
	processingInnerHtml ifTrue: [^super spanNamed: anId with: aBlock].
	self elementId: anId innerHtml: aBlock! !

!WAHtmlUpdateRenderer methodsFor: 'rebuilding' stamp: ''!
tag: aString cData: cdataString 
	self openTag: aString.
	(self document)
		text: '<!![CDATA[';
		text: cdataString;
		text: ']]>'.
	self closeTag: aString! !

!Number methodsFor: '*heracles' stamp: ''!
px
	^self printString , 'px'! !

WAComponent subclass: #HeraclesComponent
	instanceVariableNames: 'model getter setter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heracles-Widgets'!

!HeraclesComponent methodsFor: 'command' stamp: 'ajt 6/12/2005 11:15'!
aspect: aSymbol
	getter := aSymbol.
	setter := (aSymbol , ':') asSymbol! !

!HeraclesComponent methodsFor: 'command' stamp: 'ajt 6/12/2005 11:07'!
getter: aSelector
	getter := aSelector! !

!HeraclesComponent methodsFor: 'initialization' stamp: 'ajt 6/12/2005 11:02'!
initialize
	super initialize.
	getter := #contents.
	setter := #contents:! !

!HeraclesComponent methodsFor: 'query' stamp: 'ajt 6/12/2005 11:06'!
model

^
model ifNil: [model := WAStateHolder new contents: self defaultValue]! !

!HeraclesComponent methodsFor: 'command' stamp: ' 12/6/05 09:56'!
modelChanged! !

!HeraclesComponent methodsFor: 'command' stamp: ' 12/6/05 09:56'!
model: x 
	model := x.
	self modelChanged! !

!HeraclesComponent methodsFor: 'command' stamp: 'ajt 6/12/2005 11:07'!
setter: aSelector
	setter := aSelector! !

!HeraclesComponent methodsFor: 'query' stamp: 'ajt 6/12/2005 11:06'!
value
	^self model perform: getter! !

!HeraclesComponent methodsFor: 'command' stamp: 'ajt 7/14/2005 20:03'!
value: anObject
	self model perform: setter with: anObject! !

HeraclesComponent subclass: #HeraclesTextInputComponent
	instanceVariableNames: 'id displayValue cssClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heracles-Widgets'!

HeraclesTextInputComponent subclass: #HeraclesSelectionListComponent
	instanceVariableNames: 'listModel elementFormatBlock list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heracles-Widgets'!

!HeraclesSelectionListComponent methodsFor: 'query' stamp: ' 12/6/05 09:56'!
elementFormatBlock

^
elementFormatBlock! !

!HeraclesSelectionListComponent methodsFor: 'command' stamp: ' 12/6/05 09:56'!
elementFormatBlock: x

elementFormatBlock := x! !

!HeraclesSelectionListComponent methodsFor: 'initialization' stamp: 'ajt 6/12/2005 11:55'!
initialize
	super initialize.
	listModel := [#()].
	elementFormatBlock := [:value | value printString]! !

!HeraclesSelectionListComponent methodsFor: 'query' stamp: ' 12/6/05 09:56'!
listModel

^
listModel! !

!HeraclesSelectionListComponent methodsFor: 'command' stamp: ' 12/6/05 09:56'!
listModel: x

listModel := x! !

!HeraclesSelectionListComponent methodsFor: 'rendering' stamp: 'ajt 7/14/2005 20:09'!
renderContentOn: html 
	id := html ensureId.
	displayValue := self value.
	list := listModel value.
	cssClass ifNotNil: [html cssClass: cssClass].
	html onChangeDo: 
			[:index | 
			self value: (list at: index asInteger + 1)]
		scriptArguments: 'this.selectedIndex'.
	html 
		selectFromList: list
		selected: self value
		callback: [:value | self value: value]
		labels: elementFormatBlock! !

!HeraclesSelectionListComponent methodsFor: 'rendering' stamp: ' 12/6/05 09:56'!
renderLiveUpdateOn: html 
	displayValue = self value ifTrue: [^self].
	displayValue := self value.
	html elementId: id
		dom: [html selectedIndex: (list indexOf: displayValue) - 1]! !

!HeraclesTextInputComponent class methodsFor: 'As yet unclassified' stamp: ' 12/6/05 09:56'!
cssClass: arg1 
	^(self new)
		cssClass: arg1;
		yourself! !

!HeraclesTextInputComponent methodsFor: 'query' stamp: ' 12/6/05 09:56'!
cssClass

^
cssClass! !

!HeraclesTextInputComponent methodsFor: 'command' stamp: ' 12/6/05 09:56'!
cssClass: x

cssClass := x! !

!HeraclesTextInputComponent methodsFor: 'command' stamp: ' 12/6/05 09:56'!
defaultValue
	^''! !

!HeraclesTextInputComponent methodsFor: 'query' stamp: ' 12/6/05 09:56'!
displayValue

^
displayValue! !

!HeraclesTextInputComponent methodsFor: 'query' stamp: ' 12/6/05 09:56'!
id

^
id! !

!HeraclesTextInputComponent methodsFor: 'command' stamp: ' 12/6/05 09:56'!
id: x

id := x! !

!HeraclesTextInputComponent methodsFor: 'rendering' stamp: ' 12/6/05 09:56'!
renderContentOn: html 
	id := html ensureId.
	displayValue := self value.
	cssClass ifNotNil: [html cssClass: cssClass].
	html onChangeDo: [:text | self value: text].
	html textInputWithValue: displayValue callback: [:text | self value: text]! !

!HeraclesTextInputComponent methodsFor: 'rendering' stamp: 'ajt 7/14/2005 20:06'!
renderLiveUpdateOn: html 
	displayValue = self value ifTrue: [^self].
	displayValue := self value.
	html elementId: id dom: [html value: displayValue]! !

!HeraclesTextInputComponent methodsFor: 'command' stamp: ' 12/6/05 09:56'!
value: anObject 
	displayValue := anObject.
	super value: anObject! !

HeraclesComponent subclass: #HeraclesTimeComponent
	instanceVariableNames: 'hoursField minutesField'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heracles-Widgets'!

!HeraclesTimeComponent methodsFor: 'rendering' stamp: ' 12/6/05 09:56'!
children
	^Array with: hoursField with: minutesField! !

!HeraclesTimeComponent methodsFor: 'accessing' stamp: ' 12/6/05 09:56'!
defaultValue
	^Time now! !

!HeraclesTimeComponent methodsFor: 'accessing' stamp: 'ajt 7/14/2005 20:00'!
hoursString
	^self value ifNotNilDo: [:time | time hours printString] ifNil: ['']! !

!HeraclesTimeComponent methodsFor: 'accessing' stamp: 'ajt 7/14/2005 22:16'!
hoursString: aString 
	| hours minutes |
	aString isEmpty ifTrue: [^self value: nil].
	hours := aString asNumber.
	minutes := self value ifNotNilDo: [:time | time minutes] ifNil: [0].
	self value: (Time hour: hours minute: minutes second: 0)! !

!HeraclesTimeComponent methodsFor: 'initialize-release' stamp: ' 12/6/05 09:56'!
initialize
	super initialize.
	self initializeWidgets! !

!HeraclesTimeComponent methodsFor: 'initialize-release' stamp: 'ajt 7/14/2005 19:56'!
initializeWidgets
	hoursField := HeraclesTextInputComponent cssClass: 'hours'.
	hoursField model: self;
		 aspect: #hoursString.
	minutesField := HeraclesTextInputComponent cssClass: 'minutes'.
	minutesField model: self;
		 aspect: #minutesString! !

!HeraclesTimeComponent methodsFor: 'accessing' stamp: 'ajt 7/14/2005 20:21'!
minutesString
	^ self value	
		ifNotNilDo: [:time | 
(time minutes < 10 ifTrue: ['0'] ifFalse: ['']) ,
time minutes printString]
		ifNil: ['']! !

!HeraclesTimeComponent methodsFor: 'accessing' stamp: 'ajt 7/15/2005 01:27'!
minutesString: aString
	| hours minutes |
	aString isEmpty ifTrue: [^self value: nil].
	hours := self value ifNotNilDo: [:time | time hours] ifNil: [0].
	minutes := aString asNumber.
	self value: (Time hour: hours minute: minutes second: 0)! !

!HeraclesTimeComponent methodsFor: 'rendering' stamp: ' 12/6/05 09:56'!
renderContentOn: html 
	html spanClass: 'time'
		with: 
			[html
				render: hoursField;
				text: ':';
				render: minutesField]! !

!HeraclesTimeComponent methodsFor: 'rendering' stamp: ' 12/6/05 09:56'!
style
^'

.time input {
	width: 18px;
}

.time input.hours {
	text-align: right;
}

'! !

WAComponent subclass: #HeraclesExample
	instanceVariableNames: 'fromTimeWidget toTimeWidget tijdslotWidget startTime endTime predefinedTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heracles-Examples'!

!HeraclesExample methodsFor: 'as yet unclassified' stamp: 'ajt 7/14/2005 20:15'!
children
	^{ fromTimeWidget. toTimeWidget. tijdslotWidget }! !

!HeraclesExample methodsFor: 'as yet unclassified' stamp: 'ajt 7/14/2005 19:48'!
endTime
	^endTime! !

!HeraclesExample methodsFor: 'as yet unclassified' stamp: 'ajt 7/14/2005 19:52'!
endTime: aTime
	endTime := aTime.
	predefinedTime := nil! !

!HeraclesExample methodsFor: 'as yet unclassified' stamp: 'ajt 7/14/2005 22:17'!
initialize
	super initialize.
	fromTimeWidget := HeraclesTimeComponent new.

	fromTimeWidget	model: self; aspect: #startTime
.
	toTimeWidget := HeraclesTimeComponent new.
	toTimeWidget model: self; aspect: #endTime.
	tijdslotWidget := HeraclesSelectionListComponent new.

	tijdslotWidget

		listModel: [#(nil) , self predefinedTimes];

		model: self; aspect: #predefinedTime;

		elementFormatBlock: [:each | each ifNil: ['Other'] ifNotNil: [each key]]
! !

!HeraclesExample methodsFor: 'as yet unclassified' stamp: 'ajt 7/14/2005 19:50'!
predefinedTime
	^predefinedTime! !

!HeraclesExample methodsFor: 'as yet unclassified' stamp: 'ajt 7/14/2005 19:57'!
predefinedTimes
	^{ 
		'Standard' -> {Time fromString: '8:00'. Time fromString: '16:00'}.
		'Morning' -> {Time fromString: '8:00'. Time fromString: '12:00'}.
		'Lunch' -> {Time fromString: '12:00'. Time fromString: '13:00'}.
	}! !

!HeraclesExample methodsFor: 'as yet unclassified' stamp: 'ajt 7/14/2005 20:01'!
predefinedTime: aPredefinedTime
	predefinedTime := aPredefinedTime.
	predefinedTime isNil ifFalse: 
		[startTime := predefinedTime value first.
		endTime := predefinedTime value last]! !

!HeraclesExample methodsFor: 'as yet unclassified' stamp: 'ajt 7/14/2005 20:18'!
renderContentOn: html 
	html render: tijdslotWidget;
		 space; 
		span: [
			html
				 render: fromTimeWidget;
				 text: '-';
				 render: toTimeWidget]! !

!HeraclesExample methodsFor: 'as yet unclassified' stamp: 'ajt 7/14/2005 19:48'!
startTime
	^startTime! !

!HeraclesExample methodsFor: 'as yet unclassified' stamp: 'ajt 7/14/2005 20:23'!
startTime: aTime 
	startTime := aTime.
	predefinedTime := nil
! !

WAHtmlStreamDocument subclass: #WAXmlStreamDocument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heracles-Live'!

!WAXmlStreamDocument class methodsFor: 'as yet unclassified' stamp: ''!
new
	^self root: WAXmlRoot new! !

!WAXmlStreamDocument class methodsFor: 'instance creation' stamp: ''!
newFragment
	^self root: WAXmlFragmentRoot new! !

!WAXmlStreamDocument methodsFor: 'as yet unclassified' stamp: ''!
close! !

!WACallbackRegistry methodsFor: '*heracles' stamp: ''!
registerLiveActionCallback: aBlock 
	^ self storeCallback: (WALiveActionCallback new block: aBlock)! !

WAActionCallback subclass: #WALiveActionCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heracles-Live'!

!WALiveActionCallback methodsFor: 'as yet unclassified' stamp: ''!
addParametersFrom: text to: parameters 
	| stream |
	stream := text readStream.
	[stream atEnd] whileFalse: 
			[| len param |
			len := stream nextLine asInteger.
			param := stream next: len.
			stream next.
			parameters add: param]! !

!WALiveActionCallback methodsFor: 'as yet unclassified' stamp: 'ajt 7/14/2005 20:04'!
evaluateWithArgument: argument 
	| innerContext response renderer document |
	innerContext := context copy.
	response := WAResponse new.
	response contentType: 'text/xml'.
	renderer := WAHtmlUpdateRenderer context: innerContext
				callbacks: (innerContext callbacksFor: owner).
	document := WAXmlStreamDocument new stream: response stream.
	renderer context document: document.
	renderer response: [self processLiveRequest: argument renderer: renderer].
	document close.
	self session returnResponse: response! !

!WALiveActionCallback methodsFor: 'as yet unclassified' stamp: ''!
processLiveRequest: argument renderer: renderer 
	block value: argument value: renderer! !

!WALiveActionCallback methodsFor: 'as yet unclassified' stamp: ''!
session
	^WACurrentSession value! !

!WARenderLoop methodsFor: '*heracles' stamp: ''!
withRenderNowHandler: aBlock 
	^
	[aBlock on: WARenderLiveNotification
		do: 
			[:n | 
			root decorationChainDo: [:ea | ea renderLiveUpdateOn: n renderer].
			n resume]] 
			on: WARenderNotification
			do: [:n | n]! !

Notification subclass: #WARenderLiveNotification
	instanceVariableNames: 'renderer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heracles-Live'!

!WARenderLiveNotification methodsFor: 'query' stamp: ''!
renderer

^
renderer! !

!WARenderLiveNotification methodsFor: 'command' stamp: ''!
renderer: x

renderer := x! !

!WAHtmlAttributes methodsFor: '*heracles' stamp: ''!
addStyle: aString
	| assoc |
	assoc :=
		 self associations
			detect: [:ea | ea key = 'style']
			ifNone: [self associations add: 'style' -> aString. ^ self].
	assoc value: (assoc value, ' ', aString)! !

!WAAbstractHtmlBuilder methodsFor: '*heracles' stamp: ''!
cssStyle: aBlock 
	| style |
	style := WACssStyle new.
	aBlock value: style.
	self attributes addStyle: style asString! !
